#ifndef MARS_MHMatrix
#define MARS_MHMatrix

#ifndef ROOT_TMatrix
#include <TMatrix.h>
#endif
#ifndef MARS_MH
#include "MH.h"
#endif

class MDataChain;

class MHMatrix : public MH
{
protected:
    Int_t   fNumRow; // Number of dimensions of histogram
    TMatrix fM;      // Matrix to be filled

    TList  *fData;   // List of data members (columns)

    void AddRow();

    Bool_t SetupFill(const MParList *pList);
    Bool_t Fill(const MParContainer *par);
    Bool_t Finalize();

public:
    MHMatrix();
    ~MHMatrix();

    void AddColumn(const char *name);

    TMatrix &GetM() { return fM; }
    const TMatrix &GetM() const { return fM; }

    //void Draw(Option_t *opt=NULL);
    //TObject *DrawClone(Option_t *opt=NULL) const;

    void Print(Option_t *) const;

    ClassDef(MHMatrix, 1) // Multidimensional Matrix to store events
};

#endif
